;	t@CFFCD128D.asm			2005.6.13 							
;      Frequency Display with IF-offset (HF VHF UHF(128j 3stages)	 jk1xkp
;      QlāFFCDD.asm  //FCD2
;	gp
;	ohb		PIC16F84-10/PiȊOɂp\j
;		NbN	12.8MHzx TCXO
;
;  JX^}CY̎Ql
; PjTD7104P N8 ̃vOBla510́̕Am=128ŎgpB
; QjIF=Ԏg  łႢUSBLAgǂݍ܂܂B
;      vZ IF_LSB=IF+3000A IF_CW=IF+800  ,IF_AM=IF+1500 ƂĂ邽߂łB
;    IF=9.000MHz̎    USBLAg8.9985MHZ 1HzPʂœǂݍ܂܂B
;
; RjIF̓ǂݍ݁iEEPROMւSAVEj@   
;    Rb.0 Rb.5 open œdBPȂgJE^[ƂċN܂B
;   SSBWFl[^̃LAg𑪒E\܂B 
;   ̂܂܂ Rb.7 4.7kGRDɗƂƁAOFF.--vƕ\
;   EEPROM save ܂BPʂ1HzłB
;             EEPROM    Ԓn   00h    01h     02h   03h
;                             IF[0]  IF[1]  IF[3]  IF[3]
;
; Tj             LCD \̃AhX(16i)
; |01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 (j	
;---------------------------------------------------------------------
;1|80 81 82 83 84 85 86 87 88 89 8a 8b 8c 8d 8e 8f 
;2|c0 c1 c2 c3 c4 c5 c6 c7 c8 c9 ca cb cc cd ce cf

;\ʒu(g)
;   1  ,  4  8  6  m  8  6  7  ,  6  2  1  H  z  U
;   U  H  F  _  1  0  .  0  s  e  c  2  5  6  m  V   

;	tLCD		PU2 CrbPUOQb
;sATCFidENX^E̔z͏ȗj
;		( H:[qopen(LCDڑ͂njj  L:[q4.7kGRDɗƂ)
;	ohbPUeWS		tW[
;	()̓sԍ
;	GND(0V)				R/~W
;	RA4(03)				RF(Lo) input
;	RA3(02)				RA4ƐڑAgate toggle  
;	RA2(01)				
;	RA1(18)				RS 
;	RA0(17)				E(ENABLE)
;
;	GND(0V)				DB0
;	GND(0V)				DB1
;	GND(0V)				DB2
;	GND(0V)				DB3
;				
;	RB7(13)			DB4 	/L:IF save [h
;	RB6(12)			DB5	/TD7104P=1 ,=8, MB510=128
;
;	RB5(11)			DB6	/H	L	L	
;	RB4(10)			DB7	/gate time 0.25/1.0/10sec
;	RB0(06)			D	/L	L	H
;					/Lo+IF	Lo-IF	IF-Lo	Display
;
;					/
;	RB3(09)			F	/L 	H	L	H
;	RB2(08)			G	/H	H	L	L
;					/USB	LSB	CW	AM
;
;	RB1(07)			E	/H:TD7104P=1 ,  L:=8 

		.include	16f84.h		; ł͂PUeWSI

		.osc		HS		; IV[^ws
		.wdt		off		; EHb`hbOnee
		.pwrt		on		; p[Abv^C}nm
		.protect	off		; veNgnee


IN		equ	ra.4
TGL		equ	ra.3
E		equ	ra.0
RS		equ	ra.1

		org	0ch

wait_cn		ds	1
wait_cn2	ds	1
cn		ds	1
cs		ds	1		;sub-counter 
;   --------------- adress 10&H  
x		ds	4	;X́AK #10h ԒnɒuĂ
if		ds	4  	;#14hԒn;IFg  EEPROMload
vfo		ds	4	;#18hԒn;Lo(VFO)B
y		ds	4	;#1chԒn;
;   -------------- adress 20&H
dec		ds	10	;dec ͕K20hԒn; 10ii[ꏊiPOoCgj
dec_top
val		ds	4		; ϊliRQrbgj
val_m		ds	1		; ꎞ]i[ꏊiTu[`Ŏgpj
N		ds	1		;prescaler 1/N=1,2,3,4,5,6,8,9,10
;    ------------- adress 30&H
poi		ds 	1	
mode		ds	1	;FC/LH/Lo/-/CW/SSB/bt/Rev=11111111b
;                               bt=1̎100KHzȉ\Bbt=0̎100MHzȉ\B
ifdef		ds	2
overf		ds	1
sbam		ds	1	;K0ւ̕\ mode̐ U=0ah etc.
d4		ds	1
d8		ds	1
regrb		ds	1
oldrb		ds	1
ghf		ds	1	;gate time=(7bt),(6bt),(5bit),(4bit)
					;Input port= /UHF(3bt),VHF(2bt),HF(1bt),RF(0bt)
			; VHF(30`250MHz)TD7104P8;default / UHF(250`2.8GHz)MB510128
			; RF (100`1MHz) 2SK241 /  HF( 1`30MHz)TD7104P
gnum		ds	1	;0`11
mv		ds	1	;RF͓d
	
		org	0
		
		goto	start
		org	4
		goto  	start

t_hz		addwf	pc,1  		;
		retlw	0		;poi=0	1GHz
		retlw	2ch		;poi=1  letter u,v
		retlw	0		;poi=2	 100MHz
		retlw	0		;poi=3	 10MHz
		retlw	0		;poi=4	 1MHz
		retlw	6dh		;poi=5	letter umv
		retlw	0		;poi=6	 100kHz
		retlw	0		;poi=7	 10kHz
		retlw	0		;poi=8	 1kHz
		retlw	2ch		;poi=9	letter u,v
		retlw	0		;poi=10	 100Hz
		retlw	0		;poi=11	 10Hz
		retlw	0		;poi=12	 1Hz
		retlw	2eh		;poi=13	letter u.v
		retlw	0		;poi=14	 0.1Hz

t_rf		addwf	pc,1  		;
		retlw	20h		;poi=0	letter u_v
		retlw	52h		;poi=1	letter uRv
		retlw	46h		;poi=2	letter uFv

		retlw	20h		;poi=3	letter u_v
		retlw	48h		;poi=4	letter uHv
		retlw	46h		;poi=5	letter uFv

		retlw	56h		;poi=6	letter uVv
		retlw	48h		;poi=7	letter uHv
		retlw	46h		;poi=8	letter uFv

		retlw	55h		;poi=9	letter uUv
		retlw	48h		;poi=10	letter uHv
		retlw	46h		;poi=11	letter uFv
		
		retlw	4fh		;poi=12	letter uOv
		retlw	46h		;poi=13	letter uFv
		retlw	46h		;poi=14	letter uFv

		retlw	41h		;poi=12	letter uAv
		retlw	44h		;poi=13	letter uDv
		retlw	4ah		;poi=14	letter uJv

t_time		addwf	pc,1  		;
		retlw	2eh		;poi=0	letter u.v
		retlw	32h		;poi=1	letter u2v
		retlw	35h		;poi=2	letter u5v

		retlw	2eh		;poi=3	letter u.v
		retlw	33h		;poi=4	letter u3v
		retlw	32h		;poi=5	letter u2v

		retlw	31h		;poi=6	letter u1v
		retlw	2eh		;poi=7	letter u.v
		retlw	30h		;poi=8	letter u0v
		
		retlw	36h		;poi=9	letter u6v
		retlw	2eh		;poi=10	letter u.v
		retlw	34h		;poi=11	letter u4v

		retlw	38h		;poi=12	letter u8v
		retlw	2eh		;poi=13	letter u.v
		retlw	30h		;poi=14	letter u0v

		retlw	31h		;poi=15	letter u1v
		retlw	30h		;poi=16	letter u0v
		retlw	2eh		;poi=17	letter u.v

		retlw	73h		;poi=18 letter usv
		retlw	65h		;poi=19 letter uev
		retlw	63h		;poi=20 letter ucv

T_ghf		addwf	pc,1  		;gate_time{AC151 I/Pset
		retlw	00000001b	;gnum=0  0.25s(#0) xHF    N=4	(D/1)
		;//retlw	00000010b	;gnum=0  0.25s(#0) xHF    N=4	(D/1)
		retlw	00000100b	;gnum=1  0.25s(#0) xVHF   N=32	(D/8)
		retlw	00011000b	;gnum=2  0.32s(#1) xUHF   N=400	(D/128)
		retlw	00100001b	;gnum=3     1s(#2) xHF    N=1	(D/1)
		;//retlw	00100010b	;gnum=3     1s(#2) xHF    N=1	(D/1)
		retlw	00100100b	;gnum=4     1s(#2) xVHF   N=8	(D/8)
		retlw	00101000b	;gnum=5     1s(#2) xUHF   N=128	(D/128)
		retlw	01010001b	;gnum=6    10s(#5) xHF    N=1	(D/1)
		;//retlw	01010010b	;gnum=6    10s(#5) xHF    N=1	(D/1)
		retlw	01000100b	;gnum=7    8s(#4) xVHF   N=1	(D/8)
		retlw	00111000b	;gnum=8  6.4s(#3) xUHF   N=20	(D/128)

T_N		addwf	pc,1  		;{A(0<= N <=255)
		;//retlw	4	;gnum=0  N=4
		retlw	4	;gnum=0  N=4
		retlw	32	;gnum=1  N=32
		retlw	200	;gnum=2  N=200 ;200̎̂݁@[call mt_vNx2]400{B
		;//retlw	1	;gnum=4  N=1
		retlw	1	;gnum=3  N=1
		retlw	8	;gnum=4  N=8
		retlw	128	;gnum=5  N=128
		;//retlw	1	;gnum=8  N=1
		retlw	1	;gnum=6  N=1
		retlw	1	;gnum=7  N=1
		retlw	20	;gnum=8  N=20

;-----------------------------------
;--------------------------------------
c_selct		;gate time select `count` VFO[]ɒlret

		clr	vfo[0]
		clr	vfo[1]
		clr	vfo[2]
		clr	vfo[3]		

cs3		swapf	ghf,0	
		andlw	00000111b
		movwf	cn		;cn= 0    ,1    ,2    ,3    ,4    ,5 
				;gate=  0.25sec   ,0.32 ,1.0  ,6.4   ,8   ,10sec

		bsf	status,5	;oN1
		movlw	00011000b	;ra.3sIN=high impedance/TMR0̊Jn
		movwf	5		;trisA
		bcf	status,5	;oN0
		clr	ra

cs4		movf 	cn,0
		addwf	pc,1
		goto	c_main025	;cn=0,Q[g^C0.25sec 
		goto	c_main032	;cn=1,Q[g^C0.32sec
		goto	c_main100	;cn=2,Q[g^C1.0sec
		goto	c_main640	;cn=3,Q[g^C6.4sec	
		goto	c_main800	;cn=4,Q[g^C8.0sec	
		goto	c_main1000	;cn=5,Q[g^C10.0sec	

;-------------------------------------------
c_main032	
		clr	wdt		;Q[g^C0.32sec 
		clrf	tmr0		;JE^TMR0NA

	;	sleep		;temp  320 msec JEg̎n_
		
		call 	t320msec	;(2+1023,992)*cn	|  
		nop			;(1*cn) Ԓ	|  
					;			| 1023,995cycle
	
	;	sleep		;temp  250msecJEg̏I_  
		goto	cmain		;2+3		(v1024,000 step)

;-------------------------------------------
c_main100	mov	cs,#4
		clr	wdt		;Q[g^C1.0sec 
		clrf	tmr0		;JE^TMR0NA

;		sleep		;temp  1.0sec JEg̎n_
cm10_1		
		call 	t250msec	;(2+799994)*4	|  
		decfsz	cs,1		;3*3+2cycle	| 3,199,995cycle
		goto 	cm10_1		;0		|
;		sleep		;temp  1.0secJEg̏I_ 
		goto	cmain		;2+3	 (v3,200,000 step)

;-------------------------------------------
c_main640	mov	cs,#20
		clr	wdt		;Q[g^C6.4sec 
		clrf	tmr0		;JE^TMR0NA

;		sleep		;temp  6.4sec JEg̎n_
cm6_1		
		call 	t320msec	;(2+1023,992)*20|  
		nop			;1 *20 Ԓ |
		nop			;1 *20 Ԓ |
		decfsz	cs,1		;20*3+2cycle	| 20,479,982cycle
		goto 	cm6_1		;0		|

		movlw	2	;1+(1*3cycle+2+2)=8	|
		movwf	wait_cn		;1		|
		call	wait_us		;2cycle		|
		nop			;1		|
		nop			;1		|        13cycle

;		sleep		;temp  1.0secJEg̏I_  
		goto	cmain		;2+3	(v 20,480,000 step)


;-------------------------------------------
c_main800	mov	cs,#32
		clr	wdt		;Q[g^C8.0sec 
		clrf	tmr0		;JE^TMR0NA

;		sleep		;temp  8.0sec JEg̎n_
cm8_1		
		call 	t250msec	;(2+799994)*32	|  
		decfsz	cs,1		;31*3+2cycle	| 25,999,967cycle
		goto 	cm8_1		;0		|

		movlw	7	;1+(6*3cycle+2+2)=23	|
		movwf	wait_cn		;1		|
		call	wait_us		;2cycle		|	
		nop			;1		|
		nop			;1		|       28cycle

;		sleep		;temp  1.0secJEg̏I_  
		goto	cmain		;2+3	(v 25,000,000 step)

;-------------------------------------------
c_main1000	mov	cs,#40
		clr	wdt		;Q[g^C10.0sec 
		clrf	tmr0		;JE^TMR0NA

;		sleep		;temp  10.0sec JEg̎n_
cm100_1		
		call 	t250msec	;(2+799994)*40	|  
		decfsz	cs,1		;39*3+2cycle	| 31,999,959cycle
		goto 	cm100_1		;0		|

		movlw	10	;1+(9*3cycle+2+2)=32	|
		movwf	wait_cn		;1		|
		call	wait_us		;2cycle		|
		nop			;1		|        36cycle

;		sleep		;temp  1.0secJEg̏I_  
		goto	cmain		;2+3	(v 32,000,000 step)

;-------------------------------------------
c_main025	clr	wdt		;Q[g^C0.25sec 
		clrf	tmr0		;JE^TMR0NA

	;	sleep		;temp  250 msec JEg̎n_
		
		call 	t250msec	;(2+799994)*1	|  
		;					| 799,996cycle
		nop			;1  Ԓ	
	;	sleep		;temp  250msecJEg̏I_ 
;	;		goto	cmain		;3 		 (v800,000 step)	
;------------------------
cmain		bsf	status,5	;1	;oN1
		movlw	00010000b	;1	;ra.3sout;TMR0̒~
		movwf	5		;1	;trisA	;܂ 3cycle	
		bcf	porta,3		;1
		bcf	status,5	;oN0

		bcf	TGL	
		call	dl5		;overflow check after last check

cmain2		nop
		movf 	tmr0,0		;TMR0datavfo[1]
		movwf	vfo[1]

		incf	vfo[0],1
toggle		decf	vfo[0],1
		bcf	TGL		;port Ra4̃gO
		bsf	TGL
		nop
		nop
;		incf	tmr0,1		;temp

		movf	tmr0,0
		subwf	vfo[1],0	;vfo[1]-TMR0=0ł Z=1
		btfsc	z
		goto	toggle
		decf	vfo[0],1	;vfo[0]ւ prescalerl̎荞݊B
		ret
;----------------------------------
t320msec				;;1023,839 +140+1+2+1+1  +1+1+2  +1+1+2=1023,992steps
		;----------------
		movlw	46		;1+(45*3cycle+2+2)=140
		movwf	wait_cn		;1
		call	wait_us		;2cycle
		nop			;1
		nop			;1
		;---------------
		movlw	160		;;1
		movwf	cn		;;1
		goto	t200_1		;;2
					;;--160*(7*799+798+1+2+2+1+2)-1=1023,839steps
;-------------
t250msec				;799874+110+1+2+1  +1+1 +1+1+2=799994steps	
		;----------------
		movlw	36		;1+(35*3cycle+2+2)=110
		movwf	wait_cn		;1
		call	wait_us		;2cycle
		nop			;1
		;---------------
		movlw	125		;1			
		movwf	cn		;1
					;--125*(7*799+798+1+2+2+1+2)-1=799874
t200_1		call	delay249		;2+797
		call	delay249		;2+797
		call	delay249		;2+797
		call	delay249		;2+797
		call	delay249		;2+797
		call	delay249		;2+797
		call	delay249		;2+797
		call	delay248		;2+796
		
		nop				;1
		btfss	portb,6			;2
		goto	t200end

		btfss	portb,4			;2
		goto	t200end		
		
		decfsz	cn,1			;1
		goto 	t200_1			;2

t200end		movf	portb,0		;1
		movwf	regrb		;1
		ret			;2
;--------------------------------------------
delay249	nop		;797step	
delay248	;------------------------G796steps=248.0 usec̃[`------------

		movlw	253		;1+(252*3cycle+2+2)+3=764---------------------
		movwf 	wait_cn		;1cycle	 |	 	 |
		call	wait_us 	;2cycle  |      	 |

		movlw	5		;1+(4*3cycle+2+2)+15=  32---------------------
		movwf 	wait_cn		;1cycle	 |	 	 |
		call	wait_us 	;2cycle  |      	 |
dl5		movf	intcon,0	;1cycle	 |	 	 |
		movwf	overf		;1cycle	 |	 	 |
		clr	c		;1cycle  |		 |
		movlw	1		;1cycle	 |  16cy	 |
		btfsc	overf,2		;2cycle	 | 		 |
		addwf	vfo[2],1	;0	 |		 |
		btfsc	c		;2cycle	 |		 |
		addwf	vfo[3],1	;0	 |		 |	
		btfsc	overf,2		;2cycle	 |		 |
		bcf	intcon,2	;0cycle  |      	 |
		ret			;2cycle-----------------------
;--------------------------------------------------------------
start		call	wt255ms
		call	portset

		mov	sbam,#20h
		movlw	01010000b
		movwf	regrb
		movwf	oldrb	

		;//mov	gnum,#2	 	;gnum=2  0.25s(#0) xVHF   N=32
		mov	gnum,#1	 	;gnum=1  0.25s(#0) xVHF   N=32
		call	dp_on
		call	init_lcd
		call	dp_off

		mov	mode,portb	;save/-/het/-/AM/LUC/HL/het
		nop
		nop

start2		btfss	mode,0 
		goto	start3
		btfsc	mode,5
		goto	f_counter

start3		btfsc	mode,1		;if rb.1=L ,HF(1-40MHz,gnum=0) else VHF(gnum=1)
		;//movlw	2
		movlw	1
		btfss	mode,1
		movlw	0
		movwf	gnum

		call	IFload
		mov	if[0],x[0]
		mov	if[1],x[1]
		mov	if[2],x[2]
		mov	if[3],x[3]

	;	mov	if[0],#0e0h   		;test IF=10.700.000Hz
	;	mov	if[1],#44h		;test IF=10.700.000Hz
	;	mov	if[2],#0a3h		;test IF=10.700.000Hz
	;	mov	if[3],#0h		;test IF=10.700.000Hz

main
main2		call	IP_set		;74AC151 I/Pݒ
main3		call	c_selct		;count

main7		call	calc

		call	dp_on
		call	dp_fre		;1sڂ̎g\
		call	dp_off
		mov	mode,portb
		nop
		nop
		btfss	mode,7
		goto	main9
		goto	main

main9		mov	mode,portb	;mode.7gɂȂ̂҂	
		nop
		btfsc	mode,7
		goto	f_counter
		goto 	main9
;------------------------------------------------------
portset		clrf	tmr0		;TMR0NA
		bsf	status,5	;oN1
		movlw	00010000b	;ra.3-ra.0sOUT !ra,#00010000b	
		movwf	5		;trisA

		clrwdt			;prescalerNA
		movlw	01100111b	;prescaler 1/256 set ;RBvAbv; オJEg	
		movwf	option	
		bcf	status,5	;oN0

		clr	ra
		clr	rb
		ret

;------------------------------------------------------
dp_on		bsf	status,5	;oN1
		movlw	00000000b	;rb.0-rb.7sout  !rb,#00000000b	
		movwf	6		;trisb
		bcf	status,5	;oN0
		clr	rb	
		ret

		;-------------------
dp_off		bsf	status,5	;oN1
		movlw	11111111b	;rb.0-rb.7sIN  !rb,#11111111b	
		movwf	6		;trisb
		bcf	status,5	;oN0
		clr	rb	

		mov	wait_cn,#1
		call	wait_ms
		ret

;------------------------------------------------------
dp_rf		;2sڂ̕\   [VHF .25sec xxxmV]
dpr1		btfsc	ghf,0		;if ghf=xxxx0001 ,then "RF"
		movlw	3	

		;//btfsc	ghf,1		;if ghf=xxxx0010 ,then "HF"
		;//movlw	3

		btfsc	ghf,2		;if ghf=xxxx0100 ,then "VHF"
		movlw	6

		btfsc	ghf,3		;if ghf=xxxx1000 ,then "UHF"
		movlw	9		
dpr2		movwf	poi

dpr3		bcf	RS
		mov	d4,#11000000b
		call	write_lcd4	;cursor 2s 1	
		bsf	RS
		mov	cn,#3		

dpr5		movf	poi,0		;if poi=#(12-3),then "OFF"..if poi=#(15-3),then "ADJ"
		call	t_rf
		movwf	d4		;Wd4
		call	write_lcd4	;
		
		incf	poi,1
		djnz	cn,dpr5
	;------------------------------------------------------
dp_sec		mov	d4,#20h		
		call	write_lcd4	;space \

		swapf	ghf,0		;swap(ghf)W
		andlw	00000111b
		movwf	poi
		addwf	poi,1		;poi=gate time+gate time
		addwf	poi,1		;poi=3 x gate time
		
		mov	cn,#3		; ".25" sec̕\
ds1		call	ds7

		mov	cn,#3		;"sec"̕\
		mov	poi,#18
ds2		call	ds7		
		ret
		;--------------------
ds7		movf	poi,0
		call	t_time		;; ".25" sec̕\ ;;"sec"̕\
		movwf	d4		;Wd4
		call	write_lcd4	;
		incf	poi,1
		djnz	cn,ds7
		ret
;------------------------------------------------------
dp_fre		bcf	RS		;1sڎg\ [x,xxxmxxx,xxxHz]
		mov	d4,#10000000b
		call	write_lcd4	;cursor 1s 1	

		bsf	RS

		mov	cn,#13
		mov	fsr,#20h	;dec[0]̔Ԓn=20h	
		clrf	poi

		movf	ghf,0
		andlw	01110000b	
		sublw	01010000b	;if gate time=10sec ,0.1Hz\
		btfss	z
		goto	dpf1
		mov	poi,#2

dpf1		movf	poi,0		;poiW
		call	t_hz
		movwf	d4
		sublw	0
		btfss	z
		goto	dpf3

dpf2		movf	indirect,0	;dec[]W
		xorlw	00110000b	;ʂSbitɂR
		incf	fsr,1
		goto	dpf4

dpf3		movf	d4,0
dpf4		movwf	d4
		call	write_lcd4	;
		incf	poi,1
		djnz	cn,dpf1

		mov	d4,#48h		;poi=15	letter uHv
		call	write_lcd4	;
		mov	d4,#7ah		;poi=15	letter uzv
		call	write_lcd4	;	
	
		movf	sbam,0
		movwf	d4		
		call	write_lcd4	
		ret
;-----------------------------------------------
calc		
cac3		movf	gnum,0
		call	T_N
		movwf	N

clc1		movlw	200
		subwf	N,0
		btfsc	z
		call	mt_vNx2

		call	mult_vN		;x=VFO*N{ Bx[3]-x[0]ɒ{VFOĂ.
		mov	vfo[3],x[3]	;
		mov	vfo[2],x[2]
		mov	vfo[1],x[1]
		mov	vfo[0],x[0]
	;----------------	
		btfss	mode,2
		goto	clc2
		btfss	mode,3
		goto	lsb		;rb.2=H &rb.3=L
		goto	usb		;rb.2=H &rb.3=H
clc2		btfss	mode,3
		goto	cw		;rb.2=L &rb.3=L
		goto	am		;rb.2=L &rb.3=H

usb		clrf	ifdef[0]
		clrf	ifdef[1]
		movf	mode,0		;modeW
		andlw	00100001b	;rb.5 rb.0 ̂ݎc
		sublw	00000000b	;if rb.5=L & rb.0=L ,Dsp=Lo-IF (exchange USB)
		btfss	z
		movlw	55h		;USB "U"=55h
		btfsc	z
		movlw	4ch		;LSB "L"=4ch
		movwf	sbam
		goto	ifcalc

lsb		mov	ifdef[0],#0b8h	;IF=IF  ΍.  3Khz
		mov	ifdef[1],#0bh	
		
		movf	mode,0		;modeW
		andlw	00100001b	;rb.5 rb.0 ̂ݎc
		sublw	00000000b	;if rb.5=L & rb.0=L ,Dsp=Lo-IF (exchange USB)
		btfsc	z
		movlw	55h		;USB "U"=55h
		btfss	z
		movlw	4ch		;LSB "L"=4ch
		movwf	sbam
		goto	ifcalc

cw		mov	ifdef[0],#20h	;IF=IF  ΍.  0.8Khz
		mov	ifdef[1],#3h	
	
		movlw	43h		;CW "C"=43h
		movwf	sbam
		goto	ifcalc

am		mov	ifdef[0],#0dch	;IF=IF  ΍.  1.5Khz
		mov	ifdef[1],#5h	
	
		movlw	41h		;AM "A"=41h
		movwf	sbam
	;	;goto	ifcalc
;  ---------------------------------------------------------------
ifcalc		
;		mov	if[0],#0ah	;ύXԎgv899850=0dbb0a&h
;		mov	if[1],#0bbh	;ύXԎgvIF=8,998,500Hz10HzJEgȂ̂
;		mov	if[2],#0dh	;ύXԎgv
;		mov	if[3],#0	;ύXԎgv

		mov	x[3],if[3]		;l IF
		mov	x[2],if[2]		
		mov	x[1],if[1]
		mov	x[0],if[0]

		mov	y[0],ifdef[0]	; yIF̕΍
		mov	y[1],ifdef[1]	
		clr	y[2]
		clr	y[3]
		call	add_xy		;x=x+y

clc3		btfss	mode,0		;if mode.0=L ,then het
		goto	het
		btfsc	mode,5		;if mode.5=H ,then fctr else reverse
		goto	calc0		;PȂcounter
		goto	reverse

het		btfsc	mode,5		;if mode.5=L ,then lowhet
		goto 	lowhet
				;disp=Lo-IF
uphet		
		mov	y[3],x[3]		;y=IF	x[0] x[1]
		mov	y[2],x[2]		
		mov	y[1],x[1]	;
		mov	y[0],x[0]

		mov	x[3],vfo[3]	
		mov	x[2],vfo[2]		
		mov	x[1],vfo[1]
		mov	x[0],vfo[0]

  		call  	sub_xy		;x=x-y=VFO-IF
		goto	calc1

reverse				;disp=IF-Lo
		mov	y[3],vfo[3]		
		mov	y[2],vfo[2]		
		mov	y[1],vfo[1]
		mov	y[0],vfo[0]
  		call  	sub_xy		;x=x-y=IF-VFO
		goto	calc1
	
lowhet				;disp=Lo+IF
		mov	y[3],vfo[3]		
		mov	y[2],vfo[2]		
		mov	y[1],vfo[1]
		mov	y[0],vfo[0]
	
  		call  	add_xy		;x=x+y=IF+VFO
		goto	calc1		

calc0		movf	gnum,0		;PȂFreq. counteřvZ͂B
		call	T_N
		movwf	N

		movlw	200
		subwf	N,0
		btfsc	z
		call	mt_vNx2
		
		call	mult_vN		;x=VFO*N{ Bx[3]-x[0]ɒ{VFOĂ.
calc1		mov	val[3],x[3]
		mov	val[2],x[2]
		mov	val[1],x[1]
		mov	val[0],x[0] 
		call	dcmain			;16i-10iϊ
		ret
;----------------------------------------
;		t[`
init_lcd
		clrb	RS			; RS='L'

		mov	d8,#00110000b
		call	write_lcd8
		call	wt15ms			; wait 4.1msȏ
	
		mov	d8,#00110000b
		call	write_lcd8
		call	wt15ms			; wait 100usȏ
			
		mov	d8,#00110000b
		call	write_lcd8		; 0 0 0011 (3)
		
		mov	d8,#00100000b
		call	write_lcd8		; 0 0 0010 (4bit)
		
		mov	d4,#00101000b	; duty,font set9:Function set
		call	write_lcd4

		mov	d4,#00001000b		; display off
		call	write_lcd4		

		mov	d4,#00000001b	; NAR}h:Clear Display
		call	write_lcd4
		call	wt15ms		; NAI܂ő҂ Qbȏ
		
		mov	d4,#00000110b		; entry mode set
		call	write_lcd4

		mov	d4,#00001110b		; display on,cursor on
		call	write_lcd4
		ret
;
;		Srbg[hptCg[`
write_lcd4
		mov	d8,d4
		call	write_lcd8		;4ޯ
		
		mov	d8,d4
		swap	d8
		call	write_lcd8		;ʂSޯ
		ret
;
;		Wrbg[hptCg[`
;
write_lcd8	mov	cs,#4		;;d8.7d8.0 ;d8.6d8.1
		mov	val[0],d8		;;d8.5d8.2 ;d8.4d8.3
		clr	d8
wr1		bcf	c
		rlf	val[0],1
		rrf	d8,1
		djnz	cs,wr1

		mov	portb,d8			; qa|[g֏o
		nop
		bsf	E			; ds'H'
		nop
		bcf	E
		
		mov	wait_cn,#40
		call	wait_us
		ret
;--------------------------------------
wt15ms		mov	wait_cn,#15		; wait 15ms
		goto	wait_ms
;    --------------------------------------------------------------------
wait_us				;3 steps=1.2ʂ̃JEg
wait_us0	decfsz	wait_cn,1
		goto	wait_us0
		ret
;
;		I[_[̃EFCg
;
wt255ms		mov	wait_cn,#255
wait_ms
wait_ms0
		mov	wait_cn2,#0
wait_ms1
		nop	
		nop
		nop
		nop
		nop	
		nop
		nop
		
		djnz	wait_cn2,wait_ms1
		djnz	wait_cn,wait_ms0
		ret
;---------------------------------------------------------	
;	Z		(32bit)(32bit)|y(32bit)@
sub_xy
		sub	x[0],y[0]
		movlw	1
		btfss	c
		subwf	x[1],1
		btfss	c
		subwf	x[2],1
		btfss	c
		subwf	x[3],1
		
		sub	x[1],y[1]
		movlw	1
		btfss	c
		subwf	x[2],1
		btfss	c
		subwf	x[3],1
		
		sub	x[2],y[2]
		movlw	1
		btfss	c
		subwf	x[3],1
		
		sub	x[3],y[3]
		ret
;--------------------------------------------------------------------
; 	Z	(32bit)(32bit){y(32bit)@
add_xy				
		add	x[0],y[0]
		movlw	1
		btfsc	c
		addwf	x[1],1
		btfsc	c
		addwf	x[2],1
		btfsc	c
		addwf	x[3],1
		
		add	x[1],y[1]
		movlw	1
		btfsc	c
		addwf	x[2],1
		btfsc	c
		addwf	x[3],1
		
		add	x[2],y[2]
		movlw	1
		btfsc	c
		addwf	x[3],1
		
		add	x[3],y[3]
		ret
;---------------------------------------------------------------------
;	RQrbgoCiPOiϊ
;	valɂRQrbgf[^uBival[3]:val[2]:val[1]:va[0])
;	dcmainR[B	decɓi[B
;(dec[0]:dec[1]:...:dec[8]:dec[9])   dec[0]ŏʌdec[9]ŉʌ
;	ϊval͔j󂳂B
;sample:	val	= 00:00:04:D2 h
;		dec	= 00:00:00:00:00:00:01:02:03:04
;                  dec(0):dec(1):(2):(3):(4):(5):(6):(7):(8):dec(9)
;						(1,234)
dcmain
		mov	fsr,#dec_top		; i[ꏊl
		call	devide			; ŉʕϊ 
		call	devide			;10JԂ
		call	devide
		call	devide
		call	devide

		call	devide
		call	devide
		call	devide
		call	devide
		call	devide			; ŏʕϊ
		ret
;
;		POTu[`
;		POŏZ܂
;
devide		
		mov	cn,#32			; RQrbgԂ
		
		clr	val_m
devide0		
		clc
		rl	val[0]
		rl	val[1]
		rl	val[2]
		rl	val[3]
		rl	val_m
		
		movlw	11110110b
		addwf	val_m,0
		btfsc	c
		mov	val_m,w
		btfsc	c
		inc	val[0]
		
		djnz	cn,devide0
		
		dec	fsr
		mov	indirect,val_m		; ]
		ret
;----------------------------------------end of 10iϊ

mt_vNx2		clr	c		;MB510(128jgpN=200400{̌vZ
		rlf	vfo[0],1
		rlf	vfo[1],1
		rlf	vfo[2],1
		rlf	vfo[3],1
		ret
;-----------------------------------------------------------------------
;	|Z		x[32bit]=vfo[32bit] * N[8bit]
;	vfo32rbgf[^uB  ivfo[3]:vfo[2]:vfo[1]:vfo[0]) 
;       N 8ޯްuB		  N ;  ő  #255łB
;	xɓi[B ix[3]:x[2]:x[1]:x[0]) 
;		ϊ N ͔j󂳂ȂB
;
mult_vN		clr	x[3]
		clr	x[2]
		clr	x[1]
		clr	x[0]
			
		mov 	cn,#8
mult0		
		btfss	N,0
		goto	mutpas
		add	x[0],vfo[0]
		movlw	1
		btfsc	c
		addwf	x[1],1
		btfsc	c
		addwf	x[2],1
		btfsc	c
		addwf	x[3],1
		
		add	x[1],vfo[1]
		movlw	1
		btfsc	c
		addwf	x[2],1
		btfsc	c
		addwf	x[3],1
		
		add	x[2],vfo[2]
		movlw	1
		btfsc	c
		addwf	x[3],1
		
		add	x[3],vfo[3]
		
mutpas		clrb	c
		rl	vfo[0]
		rl	vfo[1]
		rl	vfo[2]
		rl	vfo[3]
		btfsc	c
		bsf	vfo[0],0

		clrb	c
		rr	N
		btfsc	c
		bsf	N,7

		djnz	cn,mult0

		mov	cn,#8
multrot		clrb	c
		rr	vfo[3]
		rr	vfo[2]
		rr	vfo[1]
		rr	vfo[0]
		btfsc	c
		bsf	vfo[3],7
		djnz	cn,multrot
		ret
;---------------------------end of |Z

f_counter		;;N rb.0=H and rb.5=H ŎgJE^[

f_c0		mov	regrb,portb	
		movlw	01010000b	
		andwf	regrb,0		
		movwf	regrb		;rb.4 &6=̂ݎc
		sublw	01010000b
		btfsc	z
		goto	f_c1

		call	gf_ch
		movf	regrb,0		;regrbW
		movwf	oldrb		;regrboldrb
		goto	f_c0
f_c1		movf	regrb,0		;regrbW
		movwf	oldrb		;regrboldrb

		call	IP_set		;74AC151 I/Pݒ
		call	dp_on
		call	dp_rf		;QsڂɃohAQ[g^C\
		call	dp_off

		call	ip1		;74AC151 I/P
		call	c_selct		;count
		call	calc0		;16i|10iϊ

		btfsc	portb,7		;if rb.7=L then IFsave 
		goto	f_c2		
		goto	IFadj		;IF̓o^		

f_c2		call	dp_on
		call	dp_fre		;1sڂ̎g\
		call	dp_off
	
f_c4		call	mvch		;RF ͓dv
		mov	val[0],mv
		clrf	val[1]
		clrf	val[2]
		clrf	val[3]

		bcf	c
		rlf	val[0]		;mV=2 x mv ;0 ` 510mV
		rlf	val[1]

		call	dcmain		;dec[7]=100mv,dec[8]=10mv,dec[9]=1mv

		call	dp_on
		bcf	RS
		mov	d4,#11001011b
		call	write_lcd4	;cursor 2s 12	

		bsf	RS
		mov	cn,#3
		mov	fsr,#27h	;dec[7]=100mv
fc_5		movf	indirect,0	;dec[]W   dec[7]100mv`dec[9]=1mv
		xorlw	00110000b
		movwf	d4
		call	write_lcd4	; \
		incf	fsr,1
		djnz	cn,fc_5
	
		mov	d4,#6dh		;[m]
		call	write_lcd4	; \

		mov	d4,#56h		;[V]
		call	write_lcd4	; \
		call	dp_off
	;-------------------------end
		goto	f_counter
;-------------------------------------------
gf_ch		movlw	01010000b
		subwf	oldrb,0
		btfss	z
		ret

gc1		btfss	regrb,4		;if rb.4=L,ghf(gate time)ύX
		;//movlw	4
		movlw	3
		btfss	regrb,6		;if rb.6=L,ghf(RF input port)ύX
		movlw	1
		
		addwf	gnum,1

		btfss	regrb,4		;if rb.4=L,ghf(gate time)ύX
		goto	gc2
		btfss	regrb,6		;if rb.6=L,ghf(RF input port)ύX
		goto	gc3
		
gc2		;//; gnum=0 4 812(0)
		;//movlw	12		;gate timeύX  
		;gnum=0 3 6 9(0)
		movlw	9		;gate timeύX  

		subwf	gnum,0		;W=gnum+(256-9)
		btfsc	c		;if gnum>=9 ,gnum=gnum-9	
		movwf	gnum
		goto	gc7

gc3		; //gnum=0 1 234(0) ,8 9 101112(8)
		; gnum=0 1 23(0) ,6 7 89(6)
		mov	cn,#3
		movlw	3
		movwf	cs		;cs=#3
		
gc4		movf	cs,0		;RF input portύX
		subwf	gnum,0		;if gnum=(3 x n) , then gnum=gnum-3
		btfsc	z
		goto	gc6
		movlw	3
		addwf	cs,1		;cs=3+ 3n ;3 or 6 or 9
		djnz	cn,gc4
		ret
gc6		movlw	3
		subwf	gnum,1		;W=gnum-3
gc7		ret	

;-------------------------
mvch			;720usec	;RF ͓dv[`	
		call	IP_set
		bsf	portb,0		;74AC151port D3I
		bsf	portb,1		;74AC151port D3I

		bsf	status,5	;oN1
		movlw	01000100b	;prescaler 1/32 set ;bit5=NbNJEg	
		movwf	option	

		movlw	00011100b	;ra2  outputinput; 0.1F[dJn
		movwf	5
		bcf	status,5	;oN0	
		bcf	intcon,2	;clr TOIF
		clrf	tmr0		;TMR0NA
		clrwdt			;prescalerNA
		
mv2		btfsc	intcon,2	;2 step;---if overflow, goto mv3			
		goto	mv3		;0	|
					;	| 1Loop=5step	
		btfss	porta,3		;1step	|	
		goto	mv2		;2step------
		movf	tmr0,0		;W TRM0
		movwf	mv
		movlw	1
		subwf	mv,0		;mv=mv-1
		btfss	c		;if C=0 ,W=0
		movlw	0
		goto	mv4			
mv3		movlw	255	
		bcf	intcon,2		;GMPwE020916
mv4		movwf	mv
		call	portset
		bcf	porta,2
		ret		
;-------------------------------------------------
IP_set		movf	gnum,0
		call	T_ghf		;ghfW
		movwf	ghf		

ip1		bsf	status,5	;oN1
		movlw	11110000b	;rb.0-rb.3sout  !rb,#11110000b	
		movwf	6		;trisb
		bcf	status,5	;oN0
		clr	rb	
		mov	portb,ghf
ip2		btfss	ghf,2		;if ghf.2=H , VHF then rb.1=H &rb.2=H
		ret

		bsf	portb,1
		bsf	portb,2
		ret
;--------------------------
IFadj		call	dp_on
		mov	poi,#15
		call	dpr3		;QsڂADJ\	
		call	dp_off

ifa2		btfss	portb,7		;rb.7 ̂rv ܂ő҂
		goto	ifa2

ifa3		call	calc1		;10i x[0]`x[3]
		call	dp_on
		call	dp_fre		;1sڂ̎g\
		call	dp_off
		call	wt255ms		;wait 255msec

ifa4		mov	mode,portb
		mov	y[0],#0a0h  	;100kHz=1 86 A0h
		mov	y[1],#86h
		mov	y[2],#1h
		clr	y[3]
		btfss	mode,4		;if TIME-SW ,-100kHz
		call	sub_xy
		btfss	mode,6		;if I/O-SW ,+100kHz
		call	add_xy

ifa6		btfsc	mode,7	
		goto	ifa3	
		call	IFsave	
		call	dp_on
ifa7		mov	poi,#12
		call	dpr3		;QsڂOFF\		
		goto	ifa7		;end LOOP
;--------------------------
IFsave		mov	poi,#0		;IF[0]   IF[1]   IF[2]  IF[3]  	
		mov   	cn,#4		;#00h    #01h    #02h   #03h 
  		mov	fsr,#10h

save1		mov	eeadr,poi
		mov	eedata,indirect
		call	datawrite
	
		inc	poi
		inc	fsr
		djnz	cn,save1
		ret
	
datawrite	clr	intcon
		bsf	rp0
		bsf	eecon1,2		;WRENޯ on

		movlw	55h
		movwf	eecon2
		movlw	0aah
		movwf	eecon2

		bsf	eecon1,1		;WRޯď
		bcf	eecon1,2		;WRENޯ off
		bcf	rp0

		call	wt15ms		; wait 15ms
		ret	
;----------------------------------------
IFload		mov	poi,#0h			;EEPROM address 0&h
		mov	fsr,#10h		;x[0] resistorw
		mov	cn,#4
load1		call	load_rt

		inc	poi
		inc	fsr
		djnz	cn,load1
		ret

load_rt		mov	eeadr,poi		;EEPROM address 0&h
		bsf	rp0			
		bsf	eecon1,0
		bcf	rp0
		mov	indirect,eedata		; X[0]-x[4]ɋL^ް
		ret
;     -----------------------------------------------------------------
